
from flask import Flask, request
from twilio.twiml.messaging_response import Message, MessagingResponse

import idc
import ida_kernwin


sms_server = Flask(__name__)

@sms_server.route('/sms', methods=['POST'])
def sms():
    number = request.form['From']
    message_body = str(request.form['Body'])

    print "Received message!: " + message_body

    try:

        ida_result = []

        def eval_wrapper():
            ida_result.append(idc.eval_idc(message_body))

            return 0

        ida_kernwin.execute_sync(eval_wrapper, ida_kernwin.MFF_FAST)

        result = ">> " + message_body + "\n" + str(ida_result[0])

    except Exception as e:
        result = "Encountered error when evaluating '{}': {}".format(message_body, e)

    resp = MessagingResponse()
    resp.message(result)

    return str(resp)
